/****************************************************
  memory test for T548/T549/T5410

*****************************************************/

#include <t54x_dsp.h>

unsigned *ptr ;

#define	DMEM_START_PTR	((unsigned *) 0x8000)
#define	DMEM_END_PTR	((unsigned *) 0xff7f)


unsigned start_data = 0xa596,
         start_data_block;
unsigned mem_inc_data = 0x97b5;
unsigned mem_wr_data;
unsigned long pass_counter=0;
int page;


main()
{
	// initialize DSP on-chip control registers
   T5410_init_dsp();

   while(1)
    {
      start_data_block= start_data;

      for(page=0; page<=3; page++)
        {
          T54X_set_dmem_page(page);

          for(mem_wr_data=start_data, ptr=DMEM_START_PTR;
	      ptr<=DMEM_END_PTR ; *ptr++ = mem_wr_data++);

          start_data += mem_inc_data ;
        }

      start_data=start_data_block;
      for(page=0; page<=3; page++)
        {
          T54X_set_dmem_page(page);
          for(mem_wr_data=start_data, ptr=DMEM_START_PTR;
	      ptr<=DMEM_END_PTR ;	)
   	   {
             if(*ptr++ != mem_wr_data++) goto error ;
	   }
          start_data += mem_inc_data ;
        }

     pass_counter++;

    }


  error:
    while(1) ;

}



