/****************************************************
  McBSP0 test for T5402/T5410

  This test asumes that McBSPs are configured as I/O pins.

  The following external jumpers are required for each McBSP:
    DR=CLKS= DX, driven by DX output
    CLKX, CLKR, FSR, FSX are configured as outputs	


*****************************************************/

#include "c54x_def.h"
#include "t54x_dsp.h"

#define DX_OUT_0      0x3f00
#define DX_OUT_1      0x3f20
#define FSX_OUT_0     0x3f00
#define FSX_OUT_1     0x3f08
#define FSR_OUT_0     0x3f00
#define FSR_OUT_1     0x3f04
#define CLKX_OUT_0    0x3f00
#define CLKX_OUT_1    0x3f02
#define CLKR_OUT_0    0x3f00
#define CLKR_OUT_1    0x3f01

#define DR_BIT_MASK   0x10
#define CLKS_BIT_MASK 0x40
#define CLKR_BIT_MASK 0x1
#define CLKX_BIT_MASK 0x2
#define FSX_BIT_MASK  0x8
#define FSR_BIT_MASK  0x4



unsigned pass_counter=0;

main()
{
   T54X_init_dsp();

   *C54X_IFR=0;        /* clear IFR/IFR */
   *C54X_IMR=0;

   *C54X_MCBSP0_SPSA = C54X_MCBSP_SBA_SPCR1;
   *C54X_MCBSP0_SPCR1 = 0;   /* configure McBSP for I/O pins */

   *C54X_MCBSP0_SPSA = C54X_MCBSP_SBA_SPCR2;
   *C54X_MCBSP0_SPCR2 = 0;


   while(1)
    {
      /* verify for McBSP-0 */
	/* set DX=1 */
      *C54X_MCBSP0_SPSA = C54X_MCBSP_SBA_PCR;

      *C54X_MCBSP0_PCR = DX_OUT_1;

      if(((*C54X_MCBSP0_PCR) & DR_BIT_MASK  ) ==0) break; 

//!!! uncomment next line for T5410/BGA with CLKS inputs
//      if(((*C54X_MCBSP0_PCR) & CLKS_BIT_MASK) ==0) break; 

	/* set DX=0 */
      *C54X_MCBSP0_PCR = DX_OUT_0;

      if((*C54X_MCBSP0_PCR & DR_BIT_MASK  ) !=0) break; 
//!!! uncomment next line for T5410/BGA with CLKS inputs
//      if((*C54X_MCBSP0_PCR & CLKS_BIT_MASK) !=0) break; 

      *C54X_MCBSP0_PCR = FSX_OUT_1;
      *C54X_MCBSP0_PCR = FSX_OUT_0;

      *C54X_MCBSP0_PCR = FSR_OUT_1;
      *C54X_MCBSP0_PCR = FSR_OUT_0;

      *C54X_MCBSP0_PCR = CLKX_OUT_1;
      *C54X_MCBSP0_PCR = CLKX_OUT_0;

      *C54X_MCBSP0_PCR = CLKR_OUT_1;
      *C54X_MCBSP0_PCR = CLKR_OUT_0;

     pass_counter++;
    }

error:
	while(1);

}



