
/*

	Writing/Reading to T54x HPI SRAM.

*/

#include <stdio.h>
#include <dos.h>
#include <stdlib.h>

#include <t54x_h.c>

#include <ips_ut.h>

unsigned long	START_SADDR = 0x0L,
                LAST_SADDR  = 0x7ffL;

unsigned long sa;
unsigned data,data_start, data_rd,
         initial_data = 0xe97f,
	 data_inc     = 0xb5f1;
int ex_status;

#define CLEAR_CURRENT_LINE  printf("\r%79s\r"," ");

char err_mess[100], dev_name[100];
unsigned sn;

unsigned long	_HPI_AMIN,_HPI_AMAX;


 main()

 { int r;


   printf("\nTORNADO-54x Host I/F HPI-r/w Test Utility. v.2.0\n");
   printf("Copyright (C) MicroLAB Systems Ltd, 1996-1998\n\n");

   if((r=T54X_open(0x350))!=T54X_OK)
       { error:
                 T54X_last_err_message(err_mess);
	         printf("\n error: %s\n",err_mess);
		 goto exit;
       }

   T54X_dev_id_data(&sn);
   T54X_dev_name(dev_name);
   sn &= 0xff;
   printf("%s board, s/n: #%x\n\n",dev_name,sn);

   switch(T54X_id())
       { case T542L_DEV_ID:
         case T548_DEV_ID:
         case T549_DEV_ID:
		_HPI_AMIN = T542L_HPIA_MIN;
                _HPI_AMAX = T542L_HPIA_MAX;
	    	break;

         case T5402_DEV_ID:
		_HPI_AMIN = T5402_HPIA_MIN;
                _HPI_AMAX = T5402_HPIA_MAX;
	    	break;

         case T5410_DEV_ID:
		_HPI_AMIN = T5410_HPIA_MIN;
                _HPI_AMAX = T5410_HPIA_MAX;
	    	break;

         case T5416_DEV_ID:
		_HPI_AMIN = T5416_HPIA_MIN;
                _HPI_AMAX = T5416_HPIA_MAX;
	    	break;


         default:
	    	printf("internal error. exit...\n\n");
	    	goto exit;
       }


   START_SADDR=_HPI_AMIN;
   printf("start HPI address [%5lXH..%5lXH]: ",_HPI_AMIN,_HPI_AMAX);
   START_SADDR=gethex(_HPI_AMIN,_HPI_AMAX,START_SADDR,
                       CR_ENABLE,ESC_MASK,&ex_status);

   if(ex_status==ESC_MASK)
            {  CLEAR_CURRENT_LINE;
               goto exit;
            }

   LAST_SADDR=_HPI_AMAX;
   printf("end   HPI address [%5lXH..%5lXH]: ",START_SADDR,_HPI_AMAX);
   LAST_SADDR=gethex(START_SADDR,_HPI_AMAX,LAST_SADDR,
                       CR_ENABLE,ESC_MASK,&ex_status);

   if(ex_status==ESC_MASK)
            {  CLEAR_CURRENT_LINE;
               goto exit;
            }

   printf("\npress ESC to abort and exit to DOS ...\n\n");

   T54X_HPI_INIT;
   T54X_CLR_HPI_ERR;
   T54X_SET_HPI_ERR_IE_ON;	// enable HPI error appears at the PC IRQ
   T54X_SET_HPI_HINT_IE_OFF;

   if(T542L_BOARD && (r=T54X_set_ecc_off())!=T54X_OK ) goto error;

   data_start = initial_data;

   while(1)
     {
	CLEAR_CURRENT_LINE;

           //-- fill HPI data using direct address mode
           data = data_start;

             if( key_pressed() && read_char()==KEY_ESC)
	       {
	         printf("\nUser aborted. status: OK\n\n");
	         goto exit;
	       }

           for (sa=START_SADDR;sa<=LAST_SADDR;sa++)
	      {
		if(sa==START_SADDR || ((sa%0x1000)==0))  printf("w");

	        T54X_SET_HPIA((unsigned)sa);
		T54X_SET_HPID(data++);
		if(T54X_HPI_ERR_DATA!=0)
		   { printf("\nerror: HPI timeout error at HPI-A %lXH\n",sa);
		     goto exit;
		   }
	      }



             // verify HPI data using address auto increment mode
           data = data_start;
           T54X_SET_HPIA((unsigned)START_SADDR);
           for (sa=START_SADDR;sa<=LAST_SADDR;sa++)
	      {
		if(sa==START_SADDR || ((sa%0x1000)==0))  printf("r");

		data_rd=T54X_HPID_AINC_DATA;
		if(T54X_HPI_ERR_DATA!=0)
		   { printf("\nerror: HPI timeout error at HPI-A %lXH\n",sa);
		     goto exit;
		   }
		if(data_rd!=data++)
		  {
		    printf("\nerror: HPI-A=%lxH data_wr=%xH  data_rd=%xH\n\n",
			      sa, --data, data_rd );
		    goto exit;

		  };
	      }

       data_start += data_inc ;
      }
	
   exit:
    ;
 }




