
/*

	Writing/Reading the T54X BANKS DATA/PROGRAM SRAM in background.

*/

#include <stdio.h>
#include <dos.h>
#include <stdlib.h>

#include <t54x_h.c>

#include <ips_ut.h>

unsigned long	START_PRAM_SADDR,
                LAST_PRAM_SADDR ,
		START_DRAM_SADDR,
                LAST_DRAM_SADDR ;

unsigned long sa;
unsigned page, smp_old;
unsigned data,*D,
	 pdata_start, ddata_start, data_rd, ppdata_start, dpdata_start,
         initial_pdata = 0xe97f,
         initial_ddata = 0xb975,
	 pdata_inc     = 0x35f1,
	 ddata_inc     = 0x9457;
	 ppdata_inc    = 0x5df7,
	 dpdata_inc    = 0xd531;
int ex_status;

char err_mess[100], dev_name[100];


#define CLEAR_CURRENT_LINE  printf("\r%79s\r"," ");


 main()

 { int r;
   unsigned sn;


   printf("\nTORNADO-54x Host I/F Memory Test Utility. v.2.1\n");
   printf("Copyright (C) MicroLAB Systems Ltd, 1996-1999\n\n");


   if((r=T54X_open(0x350))!=T54X_OK)
       { error:
                 T54X_last_err_message(err_mess);
	         printf("\n error: %s\n",err_mess);
		 goto exit;
       }

   T54X_dev_id_data(&sn);
   T54X_dev_name(dev_name);
   sn &= 0xff;
   printf("%s board, s/n: #%x\n\n",dev_name,sn);


   switch(T54X_id())
       { case T542L_DEV_ID:
		START_PRAM_SADDR = 0x0L;
                LAST_PRAM_SADDR  = 0xffffL;
		START_DRAM_SADDR = 0x0L;
                LAST_DRAM_SADDR  = 0xffffL ;
	    	break;

         case T548_DEV_ID:
         case T549_DEV_ID:
         case T5410_DEV_ID:
         case T5416_DEV_ID:
		START_PRAM_SADDR = 0x0L;
                LAST_PRAM_SADDR  = 0x1ffffL;
		START_DRAM_SADDR = 0x08000L;
                LAST_DRAM_SADDR  = 0x3ffffL ;
	    	break;

         case T5402_DEV_ID:
		START_PRAM_SADDR = 0x0L;
                LAST_PRAM_SADDR  = 0x1ffffL;
		START_DRAM_SADDR = 0x04000L;
                LAST_DRAM_SADDR  = 0x1ffffL ;
	    	break;

         default:
	    	printf("internal error. exit...\n\n");
	    	goto exit;
       }



   printf("start P-RAM address [%5lxH..%5lxH]: ",START_PRAM_SADDR,LAST_PRAM_SADDR);
   START_PRAM_SADDR=gethex(START_PRAM_SADDR,LAST_PRAM_SADDR,START_PRAM_SADDR,
                       CR_ENABLE,ESC_MASK,&ex_status);

   if(ex_status==ESC_MASK)
            {  CLEAR_CURRENT_LINE;
               goto exit;
            }

   printf("end P-RAM address   [%5lxH..%5lxH]: ",START_PRAM_SADDR,LAST_PRAM_SADDR);
   LAST_PRAM_SADDR=gethex(START_PRAM_SADDR,LAST_PRAM_SADDR,LAST_PRAM_SADDR,
                       CR_ENABLE,ESC_MASK,&ex_status);

   if(ex_status==ESC_MASK)
            {  CLEAR_CURRENT_LINE;
               goto exit;
            }

   printf("start D-RAM address [%5lxH..%5lxH]: ",START_DRAM_SADDR,LAST_DRAM_SADDR);
   START_DRAM_SADDR=gethex(START_DRAM_SADDR,LAST_DRAM_SADDR,START_DRAM_SADDR,
                       CR_ENABLE,ESC_MASK,&ex_status);

   if(ex_status==ESC_MASK)
            {  CLEAR_CURRENT_LINE;
               goto exit;
            }

   printf("end D-RAM address   [%5lxH..%5lxH]: ",START_DRAM_SADDR,LAST_DRAM_SADDR);
   LAST_DRAM_SADDR=gethex(START_DRAM_SADDR,LAST_DRAM_SADDR,LAST_DRAM_SADDR,
                       CR_ENABLE,ESC_MASK,&ex_status);

   if(ex_status==ESC_MASK)
            {  CLEAR_CURRENT_LINE;
               goto exit;
            }


   printf("\npress ESC to abort and exit to DOS ...\n\n");

   if(T542L_BOARD && (r=T54X_set_ecc_off())!=T54X_OK ) goto error;

   if(  (r=T54X_set_smp_segm(0xd800))!=T54X_OK
      ||(r=T54X_CLR_SB_ERR)!=T54X_OK
     )
       goto error;


   smp_old=T54X_SMP_RG_DATA;


   pdata_start = initial_pdata;
   ddata_start = initial_ddata;

   while(1)
     {
	CLEAR_CURRENT_LINE;

		// P-RAM cycle
           data = ppdata_start = pdata_start;
           if((r=T54X_set_smp_ptr(START_PRAM_SADDR*2L,T54X_PRAM_AREA,&D))!=T54X_OK)
	       goto error;
           for (sa=START_PRAM_SADDR;sa<=LAST_PRAM_SADDR;sa++)
	      {
		if(((sa*2L)%T54X_SMP_LEN)==0)	
		  {
		     data = ppdata_start = ppdata_start + ppdata_inc; 
	             if((r=T54X_set_smp_ptr(sa*2L,T54X_PRAM_AREA,&D))!=T54X_OK)
			       goto error;
//printf("\nsmp=%x\n",T54X_SMP_RG_DATA);
		     if(((sa*2L)%(T54X_SMP_LEN))==0) printf("pw");

   	             if( key_pressed() && read_char()==KEY_ESC)
  		       {
		         printf("\nUser aborted.\n\n");
		         goto exit;
		       }
		  }

		*(D++)=data++;

		if(T54X_SB_ERR_DATA!=0)
		  { sb_error:
			    printf("\nerror: SB error\n\n");
			    goto exit;
		  }

	      }

		// D-RAM cycle
           data = dpdata_start = ddata_start;
           if((r=T54X_set_smp_ptr(START_DRAM_SADDR*2L,T54X_DRAM_AREA,&D))!=T54X_OK)
	       goto error;
           for (sa=START_DRAM_SADDR;sa<=LAST_DRAM_SADDR;sa++)
	      {
		              // skip 0x0000..0x3fff/0x7fff bank area
		if(   ((T548_BOARD | T549_BOARD | T5410_BOARD | T5416_BOARD) && (sa & 0x8000L)==0)
		   || (T5402_BOARD  && (sa & 0xc000L)==0)
		  )  continue;

		if(((sa*2L)%T54X_SMP_LEN)==0)	
		  {
		     data = dpdata_start = dpdata_start + dpdata_inc; 
	             if((r=T54X_set_smp_ptr(sa*2L,T54X_DRAM_AREA,&D))!=T54X_OK)
			       goto error;
//printf("\nsmp=%x\n",T54X_SMP_RG_DATA);
		     if(((sa*2L)%(T54X_SMP_LEN))==0) printf("dw");

   	             if( key_pressed() && read_char()==KEY_ESC)
  		       {
		         printf("\nUser aborted.\n\n");
		         goto exit;
		       }
		  }

		*(D++)=data++;
		if(T54X_SB_ERR_DATA!=0) goto sb_error;

	      }





             // verify PRAM data
           data = ppdata_start = pdata_start;
           T54X_set_smp_ptr(START_PRAM_SADDR*2L,T54X_PRAM_AREA,&D);
           for (sa=START_PRAM_SADDR;sa<=LAST_PRAM_SADDR;sa++)
	      {
		if(((sa*2L)%T54X_SMP_LEN)==0)	
		  {
		     data = ppdata_start = ppdata_start + ppdata_inc; 
		     T54X_set_smp_ptr((sa*2L),T54X_PRAM_AREA,&D);
		     if(((sa*2L)%(T54X_SMP_LEN))==0) printf("pr");

   	             if( key_pressed() && read_char()==KEY_ESC)
  		       {
		         printf("\nUser aborted. \n\n");
		         goto exit;
		       }
		  }

		if((data_rd=*(D++))!=data++)
		  {
		    printf("\nerror: SA-P=%lxH P-data_wr=%xH  P-data_rd=%xH\n\n",
			      sa, --data, data_rd );
		    goto exit;

		  };
		if(T54X_SB_ERR_DATA!=0) goto sb_error;
	      }


             // verify DRAM data
           data = dpdata_start = ddata_start;
           T54X_set_smp_ptr(START_DRAM_SADDR*2L,T54X_DRAM_AREA,&D);
           for (sa=START_DRAM_SADDR;sa<=LAST_DRAM_SADDR;sa++)
	      {
		              // skip 0x0000..0x7fff bank area
		              // skip 0x0000..0x3fff/0x7fff bank area
		if(   ((T548_BOARD | T549_BOARD | T5410_BOARD | T5416_BOARD) && (sa & 0x8000L)==0)
		   || (T5402_BOARD  && (sa & 0xc000L)==0)
		  )  continue;

		if(((sa*2L)%T54X_SMP_LEN)==0)	
		  {
		     data = dpdata_start = dpdata_start + dpdata_inc; 
		     T54X_set_smp_ptr((sa*2L),T54X_DRAM_AREA,&D);
		     if(((sa*2L)%(T54X_SMP_LEN))==0) printf("dr");

   	             if( key_pressed() && read_char()==KEY_ESC)
  		       {
		         printf("\nUser aborted. \n\n");
		         goto exit;
		       }
		  }

		if((data_rd=*(D++))!=data++)
		  {
		    printf("\nerror: SA-D=%lxH D-data_wr=%xH  D-data_rd=%xH\n\n",
			      sa, --data, data_rd );
		    goto exit;

		  };
		if(T54X_SB_ERR_DATA!=0) goto sb_error;
	      }



       pdata_start += pdata_inc ;
       ddata_start += ddata_inc ;


      }
	

   	

   exit:

    T54X_SET_SMP_RG(smp_old);
    T54X_CLR_SB_ERR;

 }





