
/*

	Host<->DSP Communication for T54x.

*/

#include <stdio.h>
#include <string.h>
#include <dos.h>
#include <stdlib.h>

#include <ips_ut.h>
#include <mlu.h>

#include <t54x_h.c>







BYTE err_mess[200], dev_name[100];
unsigned long	START_SADDR = 0x0L,
                LAST_SADDR  = 0x7ffL;

unsigned long sa;
unsigned *D,data,data_start, data_rd, smp_old;
int ex_status;

MLU_TBDD TB;  // time bell descriptor



#define CLEAR_CURRENT_LINE  printf("\r%79s\r"," ");




#define	MCD_ADDR		(0xff00L)

#define	T542L_M_ID		0x110
#define	T542L_PRG_ID		0x111

#define	MCMND_NOP		0
#define	MCMND_SRAM_COMM		1
#define	MCMND_IRQ_COMM		2
#define	MCMND_MLOCK_TST		3
#define	MCMND_HLOCK_TST		4
#define MCMND_HPI_HINT_COMM	5

#define	MSTAT_BUSY		2
#define	MSTAT_ATTN		1
#define	MSTAT_RDY		0

#define	ERR_OK			0
#define	ERR_INV_CMND		-2
#define	ERR_INV_PARAM		-1


struct MCD_DD
 { int  	m_id,
		prg_id,
		cmnd,
		status,
		error;

   unsigned     up[4];
 };

struct MCD_DD *MCD;





char last_err_mess[100];
unsigned sn;



 main()

 { int r;


   printf("\nTORNADO-54x Test Utility. Host<-->DSP via SRAM/IRQ. MLOCK/HGLOCK/HLOCK. v.2.0\n");
   printf("Copyright (C) MicroLAB Systems Ltd, 1996-1998\n\n");

   if((r=T54X_open(0x350))!=T54X_OK)
       { error:
                 T54X_last_err_message(last_err_mess);
	         printf("\n T54X-error: %s\n",last_err_mess);
	           printf(" appl-error: %s\n",err_mess);
		 goto exit;
       }

   T54X_dev_id_data(&sn);
   T54X_dev_name(dev_name);
   sn &= 0xff;
   printf("%s board, s/n: #%x\n\n",dev_name,sn);


   T54X_SET_MRESET;
   T54X_INIT;
   T54X_HPI_INIT;
   T54X_SET_HPI_HINT_IE_OFF;	// disable all host IRQs
   T54X_SET_HPI_ERR_IE_OFF;
   if(T5402_BOARD) T54X_SET_HPI_DISABLE_OFF;

   if(T542L_BOARD && (r=T54X_set_ecc_off())!=T54X_OK ) goto error;

   if(  (r=T54X_set_smp_segm(0xd800))!=T54X_OK
      ||(r=T54X_CLR_SB_ERR)!=T54X_OK
     )
       { strcpy(err_mess,"T54X h/w error (probably not installed)");
         goto error;
       }

   smp_old=T54X_SMP_RG_DATA;

   if((r=T54X_set_smp_ptr(MCD_ADDR*2L,T54X_DRAM_AREA,&MCD))!=T54X_OK)
	       goto error;

   printf("testing DSP initialization ... ");

   MCD->m_id=-1;
   MCD->prg_id=-1;
   MCD->cmnd=-1;
   MCD->status=-1;
   MCD->error=0x7fff;
   MCD->up[0]=0xffff;
   MCD->up[1]=0xffff;

   T54X_SET_MGO;

   MLU_set_bell(1,&TB);  // set time control =1s

   while (MCD->status!=MSTAT_RDY) // wait for DSP will init or timeout
     {
       if(MLU_check_bell(&TB)<0)
	   { no_reply:
               strcpy(err_mess,"no reply from T54X");
	       goto error;
	   }
       if((r=T54X_SB_ERR_DATA)!=T54X_OK)
	   { sb_error:
               strcpy(err_mess,"SB error");
	       goto error;
	   }
     }


   if(MCD->m_id!=T542L_M_ID      ||   // validate MCD returned
      MCD->prg_id!=T542L_PRG_ID  ||
      MCD->cmnd!=MCMND_NOP      ||
      MCD->status!=MSTAT_RDY    ||
      MCD->error !=ERR_OK       ||
      MCD->up[0] !=0x5555       ||
      MCD->up[1] !=0xaaaa
     )
	   { strcpy(err_mess,"invalid T54X initialization");
	     goto error;
	   }


	//-------------------------------------------
   printf("passed\ntesting communication via SRAM ... ");

   MCD->cmnd=MCMND_SRAM_COMM;
   MCD->error=0x7fed;
   MCD->up[0]=0xffff;
   MCD->up[1]=0xffff;
   MCD->up[2]=0xffff;
   MCD->up[3]=0xffff;
   MCD->status=MSTAT_ATTN;

   MLU_set_bell(1,&TB);  // set time control =1s

   while (MCD->status!=MSTAT_RDY)
     {
       if(MLU_check_bell(&TB)<0) goto no_reply;
       if((r=T54X_SB_ERR_DATA)!=T54X_OK) goto sb_error;
     }

   if(MCD->error !=ERR_OK       ||
      MCD->up[0] !=0xfedc       ||
      MCD->up[1] !=0xba98       ||
      MCD->up[2] !=0x7654       ||
      MCD->up[3] !=0x3210
     )
	   { inv_cmnd_exec_result:
               strcpy(err_mess,"invalid command execution result");
	       goto error;
	   }


	//-------------------------------------------------
   printf("passed\ntesting communication via HM_RQ/MH_RQ ... ");
   if((r=T54X_CLR_MH_RQ)!=T54X_OK)
      {
               strcpy(err_mess,"cannot clear MH_RQ/prior");
	       goto error;
      }
   T54X_SET_MH_RQ_IE_ON;

   MCD->cmnd=MCMND_IRQ_COMM;
   MCD->error=0x7fed;
   MCD->up[0]=0xffff;
   MCD->up[1]=0xffff;
   MCD->up[2]=0xffff;
   MCD->up[3]=0xffff;

   MLU_set_bell(1,&TB);  // set time control =1s

   if((r=T54X_SET_HM_RQ)!=T54X_OK)
      { cannot_set_hm_rq:
               strcpy(err_mess,"cannot set H->M RQ");
	       goto error;
      }

   while (T54X_MH_RQ_DATA!=MLU_ON)
     {
       if(MLU_check_bell(&TB)<0) goto no_reply;
     }


   if(MCD->error !=ERR_OK       ||
      MCD->up[0] !=0x0123       ||
      MCD->up[1] !=0x4567       ||
      MCD->up[2] !=0x89ab       ||
      MCD->up[3] !=0xcdef
     )
	goto  inv_cmnd_exec_result;

   MLU_set_bell(1,&TB);
   while(MLU_check_bell(&TB)>=0);
   if((r=T54X_CLR_MH_RQ)!=T54X_OK)
      {
               strcpy(err_mess,"cannot clear MH_RQ/after");
	       goto error;
      }


	//-------------------------------------------------
   printf("passed\ntesting HPI/HINT ... ");

   if((r=T54X_HPI_HINT_DATA)!=0)
      {
               strcpy(err_mess,"HPI/HINT is not initially CLEAR");
	       goto error;
      }
   T54X_SET_MH_RQ_IE_ON;

   MCD->cmnd=MCMND_HPI_HINT_COMM;
   MCD->error=0x7fed;
   MCD->status=MSTAT_ATTN;

   MLU_set_bell(1,&TB);

   while (MCD->status!=MSTAT_RDY)
     {
       if(MLU_check_bell(&TB)<0) goto no_reply;
       if((r=T54X_SB_ERR_DATA)!=T54X_OK) goto sb_error;
     }

   if(MCD->error !=ERR_OK   )	goto  inv_cmnd_exec_result;

   if( (r=T54X_HPI_HINT_DATA)!=1 )
      {
               strcpy(err_mess,"HPI/HINT is missed");
	       goto error;
      }

   MLU_set_bell(1,&TB);
   while(MLU_check_bell(&TB)>=0);
   T54X_CLR_HPIC_HINT;
   if(T54X_HPIC_HINT_DATA!=0)
      {
               strcpy(err_mess,"cannot clear HPI/HINT /after");
	       goto error;
      }




	//---------------------------------------
   printf("passed\ntesting MLOCK ... ");
   if((r=T54X_SB_ERR_DATA)!=T54X_OK) goto sb_error;

   MCD->cmnd=MCMND_MLOCK_TST;
   MCD->error=0x7fed;
   MCD->up[0]=0xffff;
   MCD->up[1]=0xffff;
   MCD->up[2]=0xffff;
   MCD->up[3]=0xffff;
   MCD->status=MSTAT_ATTN;

   MCD->up[0]=0;
   if(MCD->up[0]!=0)
      { mlock_prior_exec_err:
               strcpy(err_mess,"MLOCK/prior memory test error");
	       goto error;
      }
   MCD->up[0]=0x9999;
   if(MCD->up[0]!=0x9999) goto mlock_prior_exec_err;
   MCD->up[0]=0x6666;
   if(MCD->up[0]!=0x6666) goto mlock_prior_exec_err;


   if((r=T54X_CLR_MH_RQ)!=T54X_OK)
      {
               strcpy(err_mess,"cannot clear MH_RQ/1");
	       goto error;
      }

   MCD->up[0]=0x0740;	// set permission flag to DSP to set MLOCK
   MLU_set_bell(1,&TB);  // set time control =1s

   while (T54X_MH_RQ_DATA!=MLU_ON)
     {
       if(MLU_check_bell(&TB)<0)
	  { printf("#1  ");
	    goto no_reply;
	  }
     }


   MCD->up[0]=0x5555;
   if(T54X_SB_ERR_DATA==T54X_OK)
      { no_sb_error:
               strcpy(err_mess,"no SB ERROR detected during MLOCK test");
	       goto error;
      }
   if((r=T54X_CLR_SB_ERR)!=T54X_OK)
      { cannot_clear_sb_error:
               strcpy(err_mess,"cannot clear SB ERROR");
	       goto error;
      }
   MCD->up[0]=0xaaaa;
   if(T54X_SB_ERR_DATA==T54X_OK) goto no_sb_error;
   if((r=T54X_CLR_SB_ERR)!=T54X_OK) goto cannot_clear_sb_error;

   if((r=T54X_CLR_MH_RQ)!=T54X_OK)
      {
               strcpy(err_mess,"cannot clear MH_RQ/2");
	       goto error;
      }

   if((r=T54X_SET_HM_RQ)!=T54X_OK)
           goto cannot_set_hm_rq; /* set test cancel flag to dsp */


   MLU_set_bell(1,&TB);  // set time control =1s
   while (T54X_MH_RQ_DATA!=MLU_ON)
     {
       if(MLU_check_bell(&TB)<0)
	  { printf("#2  ");
	    goto no_reply;
	  }
     }

   if((r=T54X_CLR_MH_RQ)!=T54X_OK)
      {
               strcpy(err_mess,"cannot clear MH_RQ/3");
	       goto error;
      }

   if(MCD->error !=ERR_OK       ||
      MCD->status!=MSTAT_RDY    ||
      MCD->up[0] !=0x9988       ||
      MCD->up[1] !=0x7766
     )
	goto  inv_cmnd_exec_result;


   MCD->up[3]=0xe987;
   if(MCD->up[3]!=0xe987)
      {
               strcpy(err_mess,"MLOCK/post memory test error");
	       goto error;
       }
   if((r=T54X_SB_ERR_DATA)!=T54X_OK) goto sb_error;




	//---------------------------------------
   printf("passed\ntesting H-GLOCK ... ");

   if(T54X_SB_GLOCK_DATA!=0 || T54X_SB_LOCK_DATA!=0)
      {
               strcpy(err_mess,"invalid initial H-GLOCK/LOCK status");
	       goto error;
       }

   MCD->cmnd=MCMND_HLOCK_TST;
   MCD->error=0x7fed;
   MCD->up[0]=0xffff;
   MCD->status=MSTAT_ATTN;

   if((r=T54X_SB_ERR_DATA)!=T54X_OK) goto sb_error;

   MCD->up[0]=0x0000;	
   if((r=T54X_SB_ERR_DATA)!=T54X_OK) goto sb_error;
   MLU_set_bell(1,&TB);
   while ( MCD->up[0]!=0xffff)
     {
       if(MLU_check_bell(&TB)<0) goto no_reply;
     }

   MCD->up[0]=0x0000;	
   if((r=T54X_SB_ERR_DATA)!=T54X_OK) goto sb_error;
   MLU_set_bell(1,&TB);
   while ( MCD->up[0]!=0xffff)
     {
       if(MLU_check_bell(&TB)<0) goto no_reply;
     }

   T54X_SET_SB_GLOCK_ON;
   if(T54X_SB_GLOCK_DATA==0 || T54X_SB_LOCK_DATA!=0)
      {
               strcpy(err_mess,"cannot set H-GLOCK");
	       goto error;
       }

   if(T54X_SB_ACK_DATA!=1)
      {
               strcpy(err_mess,"no SB_ACK for H-GLOCK");
	       goto error;
       }


   MCD->up[0]=0x0000;	
   if((r=T54X_SB_ERR_DATA)!=T54X_OK) goto sb_error;
   MLU_set_bell(0.3,&TB);
   while ( MCD->up[0]!=0xffff)
     {
       if(MLU_check_bell(&TB)<0) break;
     }

   MCD->up[0]=0x0000;	
   if((r=T54X_SB_ERR_DATA)!=T54X_OK) goto sb_error;
   MLU_set_bell(0.3,&TB);
   while ( MCD->up[0]!=0xffff)
     {
       if(MLU_check_bell(&TB)<0) break;
     }

   T54X_SET_SB_GLOCK_OFF;
   if(T54X_SB_GLOCK_DATA!=0 || T54X_SB_LOCK_DATA!=0)
      {
               strcpy(err_mess,"cannot clear H-GLOCK");
	       goto error;
       }


   MCD->up[0]=0x0000;	
   if((r=T54X_SB_ERR_DATA)!=T54X_OK) goto sb_error;
   MLU_set_bell(1,&TB);
   while ( MCD->up[0]!=0xffff)
     {
       if(MLU_check_bell(&TB)<0) goto no_reply;
     }

   MCD->up[0]=0x0000;	
   if((r=T54X_SB_ERR_DATA)!=T54X_OK) goto sb_error;
   MLU_set_bell(1,&TB);
   while ( MCD->up[0]!=0xffff)
     {
       if(MLU_check_bell(&TB)<0) goto no_reply;
     }


   MCD->up[0]=0x8000;	
   if((r=T54X_SB_ERR_DATA)!=T54X_OK) goto sb_error;
   MLU_set_bell(1,&TB);
   while (MCD->status!=MSTAT_RDY)
     {
       if(MLU_check_bell(&TB)<0) goto no_reply;
       if((r=T54X_SB_ERR_DATA)!=T54X_OK) goto sb_error;
     }
   if(MCD->error !=ERR_OK       ||
      MCD->status!=MSTAT_RDY    ||
      MCD->up[0] !=0x7fff
     )
	goto  inv_cmnd_exec_result;
   if((r=T54X_SB_ERR_DATA)!=T54X_OK) goto sb_error;




	//---------------------------------------
   printf("passed\ntesting H-LOCK ... ");

   if(T54X_SB_GLOCK_DATA!=0 || T54X_SB_LOCK_DATA!=0)
      {
               strcpy(err_mess,"invalid initial H-GLOCK/LOCK status");
	       goto error;
       }

   MCD->cmnd=MCMND_HLOCK_TST;
   MCD->error=0x7fed;
   MCD->up[0]=0xffff;
   MCD->status=MSTAT_ATTN;

   if((r=T54X_SB_ERR_DATA)!=T54X_OK) goto sb_error;

   MCD->up[0]=0x0000;	
   if((r=T54X_SB_ERR_DATA)!=T54X_OK) goto sb_error;
   MLU_set_bell(1,&TB);
   while ( MCD->up[0]!=0xffff)
     {
       if(MLU_check_bell(&TB)<0) goto no_reply;
     }

   MCD->up[0]=0x0000;	
   if((r=T54X_SB_ERR_DATA)!=T54X_OK) goto sb_error;
   MLU_set_bell(1,&TB);
   while ( MCD->up[0]!=0xffff)
     {
       if(MLU_check_bell(&TB)<0) goto no_reply;
     }

   T54X_SET_SB_LOCK_ON;
   if(T54X_SB_LOCK_DATA==0 || T54X_SB_GLOCK_DATA!=0)
      {
               strcpy(err_mess,"cannot set H-LOCK");
	       goto error;
       }

   if(T54X_SB_ACK_DATA!=0)
      {
               strcpy(err_mess,"SB_ACK is set immediatly after H-LOCK");
	       goto error;
       }

   MCD->up[0]=0x0000;	
   if((r=T54X_SB_ERR_DATA)!=T54X_OK) goto sb_error;

   if(T54X_SB_ACK_DATA!=1)
      {
               strcpy(err_mess,"no SB_ACK for H-LOCK after first SB RQ");
	       goto error;
       }

   MLU_set_bell(0.3,&TB);
   while ( MCD->up[0]!=0xffff)
     {
       if(MLU_check_bell(&TB)<0) break;
     }

   MCD->up[0]=0x0000;	
   if((r=T54X_SB_ERR_DATA)!=T54X_OK) goto sb_error;
   MLU_set_bell(0.3,&TB);
   while ( MCD->up[0]!=0xffff)
     {
       if(MLU_check_bell(&TB)<0) break;
     }

   T54X_SET_SB_LOCK_OFF;
   if(T54X_SB_LOCK_DATA!=0 || T54X_SB_GLOCK_DATA!=0)
      {
               strcpy(err_mess,"cannot clear H-LOCK");
	       goto error;
       }


   MCD->up[0]=0x0000;	
   if((r=T54X_SB_ERR_DATA)!=T54X_OK) goto sb_error;
   MLU_set_bell(1,&TB);
   while ( MCD->up[0]!=0xffff)
     {
       if(MLU_check_bell(&TB)<0) goto no_reply;
     }

   MCD->up[0]=0x0000;	
   if((r=T54X_SB_ERR_DATA)!=T54X_OK) goto sb_error;
   MLU_set_bell(1,&TB);
   while ( MCD->up[0]!=0xffff)
     {
       if(MLU_check_bell(&TB)<0) goto no_reply;
     }

   MCD->up[0]=0x8000;	
   if((r=T54X_SB_ERR_DATA)!=T54X_OK) goto sb_error;
   MLU_set_bell(1,&TB);
   while (MCD->status!=MSTAT_RDY)
     {
       if(MLU_check_bell(&TB)<0) goto no_reply;
       if((r=T54X_SB_ERR_DATA)!=T54X_OK) goto sb_error;
     }
   if(MCD->error !=ERR_OK       ||
      MCD->status!=MSTAT_RDY    ||
      MCD->up[0] !=0x7fff
     )
	goto  inv_cmnd_exec_result;
   if((r=T54X_SB_ERR_DATA)!=T54X_OK) goto sb_error;




   printf("passed\n\n");


   exit:
//    T54X_INIT;
   ;
 }





