/***************************************************************************

  TORNADO-54X Host Control Utilities. v.3.1
  (C) MicroLAB Systems Ltd, 1994-2001

  note: this file include definitions and function declarations only
	(should be used in conjunction with T54X_H.C file in order to
         keep definitions and vars/functions separately in a library manner)

****************************************************************************/

#define	T54X_ON					1
#define	T54X_OFF				0

typedef unsigned char BYTE ; 

#define	T54X_OK					0		// error codes
#define	T54X_PARAM_ERR			-1
#define	T54X_SMP_OFF_ERR		-3
#define	T54X_HW_ERR				-5
#define	T54X_NOT_OPEN_ERR		-10
#define	T54X_NOT_FOUND_ERR		-11
#define T54X_INV_CMND_ERR		-12


//================= T54x specific definitions ==============================

#define T54X_PRAM_SADDR			0L
#define T542L_PRAM_EADDR		0x0ffffL  // C542 p-mem end addr
#define T548_PRAM_EADDR			0x1ffffL  // C548 p-mem end addr
#define T549_PRAM_EADDR			0x1ffffL  // C549 p-mem end addr
#define T5402_PRAM_EADDR		0x1ffffL  // C5402 p-mem end addr
#define T5410_PRAM_EADDR		0x1ffffL  // C5410 p-mem end addr
#define T5416_PRAM_EADDR		0x1ffffL  // C5410 p-mem end addr
#define T54X_PRAM_EADDR_MAX		0x1ffffL  // max T54X PRAM-eaddr

#define T54X_DRAM_SADDR			0L
#define T54X_DRAM_EADDR			0x0ffffL  // C54x DATA
#define T542L_DRAM_EADDR		0x0ffffL  // T542L max DATA address
#define T548_DRAM_EADDR			0x0ffffL  // T548 max DATA address
#define T548_XDRAM_EADDR		0x3ffffL  // T548 max ext-DATA address
#define T549_DRAM_EADDR			0x0ffffL  // T549 max DATA address
#define T549_XDRAM_EADDR		0x3ffffL  // T549 max ext-DATA address
#define T5402_DRAM_EADDR		0x0ffffL  // T5402 max DATA address
#define T5402_XDRAM_EADDR		0x1ffffL  // T5402 max ext-DATA address
#define T5410_DRAM_EADDR		0x0ffffL  // T5410 max DATA address
#define T5410_XDRAM_EADDR		0x3ffffL  // T5410 max ext-DATA address
#define T5416_DRAM_EADDR		0x0ffffL  // T5416 max DATA address
#define T5416_XDRAM_EADDR		0x3ffffL  // T5416 max ext-DATA address
#define T54X_DRAM_EADDR_MAX		0x3ffffL  // max T54X DRAM-eaddr

#define T54X_IO_SADDR			0L
#define T54X_IO_EADDR			0xffffL  // C54x IOe
#define T54X_IO_EADDR_MAX		0xffffL  // max T54X IO-eaddr

#define T542L_DSP_ONCHIP_DARAM_SADDR	0x0000L  // T542L on-chip DARAM memory
#define T542L_DSP_ONCHIP_DARAM_EADDR	0x27ffL
#define T548_DSP_ONCHIP_DARAM_SADDR		0x0000L  // T548 on-chip DARAM memory
#define T548_DSP_ONCHIP_DARAM_EADDR		0x7fffL
#define T549_DSP_ONCHIP_DARAM_SADDR		0x0000L  // T549 on-chip DARAM memory
#define T549_DSP_ONCHIP_DARAM_EADDR		0x7fffL
#define T5402_DSP_ONCHIP_DARAM_SADDR	0x0000L  // T5402 on-chip DARAM memory
#define T5402_DSP_ONCHIP_DARAM_EADDR	0x3fffL
#define T5410_DSP_ONCHIP_DARAM_SADDR	0x0000L  // T5410 on-chip DARAM memory
#define T5410_DSP_ONCHIP_DARAM_EADDR	0x7fffL
#define T5416_DSP_ONCHIP_DARAM_SADDR	0x0000L  // T5416 on-chip DARAM memory
#define T5416_DSP_ONCHIP_DARAM_EADDR	0x7fffL

#define T542L_DSP_ONCHIP_PRAM_SADDR		0x0000L
#define T542L_DSP_ONCHIP_PRAM_EADDR		0x27ffL	
#define T548_DSP_ONCHIP_PRAM_SADDR		0x0000L
#define T548_DSP_ONCHIP_PRAM_EADDR		0x7fffL
#define T549_DSP_ONCHIP_PRAM_SADDR		0x0000L
#define T549_DSP_ONCHIP_PRAM_EADDR		0x7fffL
#define T5402_DSP_ONCHIP_PRAM_SADDR		0x0000L
#define T5402_DSP_ONCHIP_PRAM_EADDR		0x3fffL
#define T5410_DSP_ONCHIP_PRAM_SADDR		0x0000L
#define T5410_DSP_ONCHIP_PRAM_EADDR		0x7fffL
#define T5416_DSP_ONCHIP_PRAM_SADDR		0x0000L
#define T5416_DSP_ONCHIP_PRAM_EADDR		0x7fffL

#define T548_DSP_XDRAM_BANK_SADDR		0x08000L
#define T548_DSP_XDRAM_BANK_EADDR		0x0ffffL
#define T548_DSP_XDRAM_BANK_OVLY_ADDR	0x10000L
#define T549_DSP_XDRAM_BANK_SADDR		0x08000L
#define T549_DSP_XDRAM_BANK_EADDR		0x0ffffL
#define T549_DSP_XDRAM_BANK_OVLY_ADDR	0x10000L
#define T5402_DSP_XDRAM_BANK_SADDR		0x04000L
#define T5402_DSP_XDRAM_BANK_EADDR		0x0ffffL
#define T5402_DSP_XDRAM_BANK_OVLY_ADDR	0x10000L
#define T5410_DSP_XDRAM_BANK_SADDR		0x08000L
#define T5410_DSP_XDRAM_BANK_EADDR		0x0ffffL
#define T5410_DSP_XDRAM_BANK_OVLY_ADDR	0x10000L
#define T5416_DSP_XDRAM_BANK_SADDR		0x08000L
#define T5416_DSP_XDRAM_BANK_EADDR		0x0ffffL
#define T5416_DSP_XDRAM_BANK_OVLY_ADDR	0x10000L

#define	T542L_DEV_ID				0x3000
#define	T548_DEV_ID					0x3100	/* T548/549 rev.1.x had this DEV_ID */
#define	T549_DEV_ID					0x3200
#define	T5402_DEV_ID				0x3300
#define	T5410_DEV_ID				0x3400
#define	T5416_DEV_ID				0x3500

#define	T54X_IO_BADDR_CNF_QTY		8
#define	T54X_SMP_SEGM_CNF_QTY		8
#define	T54X_IO_BADDR_DEFAULT		0x350
#define	T54X_SMP_SEGM_DEFAULT		0xd800
#define T54X_SMP_LEN				0x8000
#define	T54X_SMP_OFF				0


unsigned T54X_io_baddr();
unsigned T54X_smp_segm();
unsigned T54X_id();
unsigned T54X_emu_io_baddr();
unsigned T54X_io_baddr_table(int);
unsigned T54X_smp_segm_table(int);
unsigned T54X_ecc_io_baddr_table(int);
unsigned T54X_uecm_io_baddr_table(int);


//------------------- T54X I/O registers ---------------------- 
#define	 T54X_SMP_RG			(T54X_io_baddr())  // T54X I/O registers
#define  T54X_SMP_RG_LSB		(T54X_io_baddr())
#define  T54X_SMP_RG_MSB		(T54X_io_baddr()+1)
#define  T54X_CNTR_RG			(T54X_io_baddr()+2)
#define  T54X_FDATA_RG			(T54X_io_baddr()+3)
#define  T54X_FSEL_RG			(T54X_io_baddr()+0x403)
#define  T54X_HPIC_RG			(T54X_io_baddr()+8)
#define  T54X_HPIC_RG_LSB		(T54X_io_baddr()+8)
#define  T54X_HPIC_RG_MSB		(T54X_io_baddr()+9)
#define  T54X_HPID_RG_AINC		(T54X_io_baddr()+10)
#define  T54X_HPID_RG_AINC_LSB		(T54X_io_baddr()+10)
#define  T54X_HPID_RG_AINC_MSB		(T54X_io_baddr()+11)
#define  T54X_HPIA_RG			(T54X_io_baddr()+12)
#define  T54X_HPIA_RG_LSB		(T54X_io_baddr()+12)
#define  T54X_HPIA_RG_MSB		(T54X_io_baddr()+13)
#define  T54X_HPID_RG			(T54X_io_baddr()+14)
#define  T54X_HPID_RG_LSB		(T54X_io_baddr()+14)
#define  T54X_HPID_RG_MSB		(T54X_io_baddr()+15)

#define  T54X_PRAM_AREA_SEL		0x0000	// SMP/MSB rg area codes
#define  T54X_DRAM_AREA_SEL		0x4000
#define  T54X_IO_AREA_SEL		0x8000
#define  T54X_AREA_SEL_BITMASK		0xC000

#define T54X_MRESET_RESET 		0x0		// Control Register bits
#define T54X_MRESET_GO			0x1
#define T54X_MRESET_BITMASK		0x1

#define T54X_SB_GLOCK_BITMASK		0x4
#define T54X_SB_LOCK_BITMASK		0x8

#define T54X_SB_ERR_IE_BITMASK		0x80
#define T54X_MH_RQ_IE_BITMASK		0x40


#define T54X_SB_ACK_FLAG_BITMASK	0x1		// SYSTEM STATUS FRG bits
#define T54X_SB_ERR_FLAG_BITMASK	0x80
#define T54X_MH_RQ_FLAG_BITMASK		0x40
#define T54X_HPI_HINT_FLAG_BITMASK	0x20
#define T54X_HPI_ERR_FLAG_BITMASK	0x2

#define T54X_SYS_STAT_FRG		0x10		
#define T54X_CLR_MH_RQ_FRG		0x20		
#define T54X_CLR_SB_ERR_FRG		0x30
#define T54X_SET_HM_RQ_FRG		0x10
#define T54X_CLR_HPI_ERR_FRG		0x40
#define T54X_HPI_IE_FRG			0x50
#define T54X_DSP_STAT_FRG		0x60
#define T54X_ISA_MI_BADDR_FRG		0xE0
#define T54X_ECC_IO_BADDR_FRG		0xE2
#define T54X_DEV_ID0_FRG		0xF0
#define T54X_DEV_ID1_FRG		0xF1

#define T54X_HPI_ERR_IE_BITMASK		0x2
#define T54X_HPI_HINT_IE_BITMASK	0x20
#define T54X_HPI_DISABLE_BITMASK	0x10

#define T54X_DSP_MLOCK_BITMASK		0x1
#define T54X_DSP_MRESET_BITMASK		0x2
#define T54X_DSP_HPI_DISABLE_BITMASK	0x10


//-------------------------------------------------------------------------



//----------------------- macros for CONTROL REGISTER -----------------------------

#define T54X_CNTR_RG_DATA		inp(T54X_CNTR_RG)
#define T54X_SET_CNTR_RG(d)		outp(T54X_CNTR_RG,d)

#define T54X_MRESET_DATA		(inp(T54X_CNTR_RG) & T54X_MRESET_BITMASK)
#define T54X_SET_MRESET			outp(T54X_CNTR_RG,inp(T54X_CNTR_RG)&~T54X_MRESET_BITMASK)
#define T54X_SET_MGO			outp(T54X_CNTR_RG,inp(T54X_CNTR_RG)&~T54X_MRESET_BITMASK | T54X_MRESET_GO)

#define T54X_SB_GLOCK_DATA		(inp(T54X_CNTR_RG) &  T54X_SB_GLOCK_BITMASK)
#define T54X_SET_SB_GLOCK_ON		outp(T54X_CNTR_RG,inp(T54X_CNTR_RG) |  T54X_SB_GLOCK_BITMASK)
#define T54X_SET_SB_GLOCK_OFF		outp(T54X_CNTR_RG,inp(T54X_CNTR_RG) & ~T54X_SB_GLOCK_BITMASK)
#define T54X_SB_LOCK_DATA		(inp(T54X_CNTR_RG) &  T54X_SB_LOCK_BITMASK)
#define T54X_SET_SB_LOCK_ON		outp(T54X_CNTR_RG,inp(T54X_CNTR_RG) |  T54X_SB_LOCK_BITMASK)
#define T54X_SET_SB_LOCK_OFF		outp(T54X_CNTR_RG,inp(T54X_CNTR_RG) & ~T54X_SB_LOCK_BITMASK)

#define T54X_SB_ERR_IE_DATA		(inp(T54X_CNTR_RG) &  T54X_SB_ERR_IE_BITMASK)
#define T54X_SET_SB_ERR_IE_ON		outp(T54X_CNTR_RG,inp(T54X_CNTR_RG) |  T54X_SB_ERR_IE_BITMASK)
#define T54X_SET_SB_ERR_IE_OFF		outp(T54X_CNTR_RG,inp(T54X_CNTR_RG) & ~T54X_SB_ERR_IE_BITMASK)

#define T54X_MH_RQ_IE_DATA		(inp(T54X_CNTR_RG) &  T54X_MH_RQ_IE_BITMASK)
#define T54X_SET_MH_RQ_IE_ON		outp(T54X_CNTR_RG,inp(T54X_CNTR_RG) |  T54X_MH_RQ_IE_BITMASK)
#define T54X_SET_MH_RQ_IE_OFF		outp(T54X_CNTR_RG,inp(T54X_CNTR_RG) & ~T54X_MH_RQ_IE_BITMASK)

#define T54X_INIT			{outpw(T54X_CNTR_RG,T54X_MRESET_RESET);T54X_clr_sb_err();T54X_clr_mh_rq();}


//------------------ macros for FLAGs control/status --------------------

int	T54X_set_fsel_rg_verif(unsigned frg);
int	T54X_set_frg_verif(unsigned frg,BYTE value);
BYTE	T54X_frg_data(unsigned frg);
BYTE	T54X_sys_stat_frg_data();
int	T54X_sb_err_data();
int	T54X_sb_ack_data();
int	T54X_mh_rq_data();
int	T54X_hpi_hint_data();
int	T54X_hpi_err_data();
int	T54X_set_hm_rq();
int	T54X_clr_sb_err();
int	T54X_clr_mh_rq();
int	T54X_clr_hpi_err();
int	T54X_hpi_err_ie_data();
int	T54X_hpi_hint_ie_data();
int	T54X_hpi_ie_frg_data();
int	T54X_set_hpi_hint_ie(int);
int	T54X_set_hpi_hint_ie(int);
int	T54X_set_hpi_err_ie(int);
int	T54X_set_hpi_disable(int);	// !! T5402 only
int	T54X_hpi_disable();
int	T54X_dsp_stat_frg_data();
int	T54X_dsp_mlock_data();
int	T54X_dsp_mreset_data();
int	T54X_dsp_hpi_disable_data();

#define T54X_FSEL_RG_DATA		inp(T54X_FSEL_RG)
#define T54X_SET_FSEL_RG(n)		outp(T54X_FSEL_RG,n)
#define	T54X_SET_FSEL_RG_VERIF(n)	T54X_set_fsel_rg_verif(n)

#define T54X_FDATA_RG_DATA		inp(T54X_FDATA_RG)
#define T54X_SET_FDATA_RG(n)		outp(T54X_FDATA_RG,n)

#define T54X_SET_FRG_VERIF(r,v)		T54X_set_frg_verif(r,v)
#define T54X_FRG_DATA(r)		T54X_frg_data(r)

#define T54X_SYS_STAT_FRG_DATA		T54X_sys_stat_frg_data()
#define T54X_SB_ERR_DATA		T54X_sb_err_data()
#define T54X_SB_ACK_DATA		T54X_sb_ack_data()
#define T54X_MH_RQ_DATA			T54X_mh_rq_data()
#define T54X_HPI_HINT_DATA		T54X_hpi_hint_data()
#define T54X_HPI_ERR_DATA		T54X_hpi_err_data()

#define T54X_SET_HM_RQ			T54X_set_hm_rq()
#define T54X_CLR_SB_ERR			T54X_clr_sb_err()
#define T54X_CLR_MH_RQ			T54X_clr_mh_rq()
#define T54X_CLR_HPI_ERR		T54X_clr_hpi_err()

#define T54X_HPI_IE_FRG_DATA		T54X_hpi_ie_frg_data()
#define T54X_HPI_ERR_IE_DATA		T54X_hpi_err_ie_data()
#define T54X_HPI_HINT_IE_DATA		T54X_hpi_hint_ie_data()
#define T54X_HPI_DISABLE_DATA		T54X_hpi_disable_data()
#define T54X_SET_HPI_ERR_IE_ON		T54X_set_hpi_err_ie(T54X_ON)
#define T54X_SET_HPI_ERR_IE_OFF		T54X_set_hpi_err_ie(T54X_OFF)
#define T54X_SET_HPI_HINT_IE_OFF	T54X_set_hpi_hint_ie(T54X_OFF)
#define T54X_SET_HPI_HINT_IE_ON		T54X_set_hpi_hint_ie(T54X_ON)
#define T54X_SET_HPI_DISABLE_ON		T54X_set_hpi_disable(T54X_ON)
#define T54X_SET_HPI_DISABLE_OFF	T54X_set_hpi_disable(T54X_OFF)

#define T54X_DSP_STAT_FRG_DATA		T54X_dsp_stat_frg_data()
#define T54X_DSP_MLOCK_DATA		T54X_dsp_mlock_data()
#define T54X_DSP_MRESET_DATA		T54X_dsp_mreset_data()
#define T54X_DSP_HPI_DISABLE_DATA	T54X_dsp_hpi_disable_data()

//==================== macros for SMP ===============================

#define	T54X_PRAM_AREA			0
#define	T54X_DRAM_AREA			1
#define	T54X_IO_AREA			2

#define T54X_SET_SMP_RG(page)		outpw(T54X_SMP_RG,page)
#define T54X_SMP_RG_DATA		inpw(T54X_SMP_RG)

#define T54X_SET_SMP_SEGM(s)		T54X_set_smp_segm(s)
#define T54X_SET_SMP_OFF		T54X_set_smp_off()

#define __MK_FP__(seg,offs)		((void far *)(((unsigned long)(seg) << 16) | (unsigned)(offs)))
#define T54X_MAKE_SMP(saddr)		((unsigned)( (long)(saddr/T54X_SMP_LEN)))
#define T54X_MAKE_SMP_PTR(saddr)	(__MK_FP__(_t54x_smp_segm,(unsigned)((long)(saddr%T54X_SMP_LEN))))


int	T54X_set_smp_segm(unsigned segm);
int	T54X_set_smp_off();
int	T54X_smp_ptr(unsigned long addr,unsigned area,unsigned *page,void **p);
int	T54X_set_smp_ptr(unsigned long addr,unsigned area,void **p);

//------------------ macros/function for DEV_ID access --------------------

int	T54X_dev_id_data(unsigned *dev_id);
int	T54X_dev_name(char *s);

#define T54X_dev_id(s)	T54X_dev_id_data(s)
#define	T542L_BOARD	(T54X_id()==T542L_DEV_ID)
#define	T548_BOARD	(T54X_id()==T548_DEV_ID)
#define	T549_BOARD	(T54X_id()==T549_DEV_ID)
#define	T5402_BOARD	(T54X_id()==T5402_DEV_ID)
#define	T5410_BOARD	(T54X_id()==T5410_DEV_ID)
#define	T5416_BOARD	(T54X_id()==T5416_DEV_ID)


//--------------------- macros for HPI access ----------------------------
#define	T54X_HPIC_BOB_BITMASK		0x1
#define	T54X_HPIC_SMODE_BITMASK		0x2
#define	T54X_HPIC_HINT_BITMASK		0x8
#define	T54X_HPIC_XHPIA_BITMASK		0x10
#define T54X_HPIC_READ_BITMASK  	(T54X_HPIC_BOB_BITMASK | T54X_HPIC_SMODE_BITMASK | T54X_HPIC_HINT_BITMASK | T54X_HPIC_XHPIA_BITMASK)

#define	T54X_HPIA_MIN			0x0000	//!! valid for T542L/548/549 only
#define	T54X_HPIA_MAX			0x07ff	//   (provided for compatibility only)
#define	T54X_HPI_RAM_LEN		(T54X_HPIA_MAX-T54X_HPIA_MIN+1)

#define	T542L_HPIA_MIN			0x0000
#define	T542L_HPIA_MAX			0x07ff
#define	T542L_HPI_RAM_LEN		(T542L_HPIA_MAX-T542L_HPIA_MIN+1)
#define	T548_HPIA_MIN			0x0000
#define	T548_HPIA_MAX			0x07ff
#define	T548_HPI_RAM_LEN		(T548_HPIA_MAX-T548_HPIA_MIN+1)
#define	T549_HPIA_MIN			0x0000
#define	T549_HPIA_MAX			0x07ff
#define	T549_HPI_RAM_LEN		(T549_HPIA_MAX-T549_HPIA_MIN+1)
#define	T5402_HPIA_MIN			0x0060
#define	T5402_HPIA_MAX			0x3fff
#define	T5402_HPI_RAM_LEN		(T5402_HPIA_MAX-T5402_HPIA_MIN+1)

#define	T5410_HPIA_MIN			0x0060
#define	T5410_HPIA_MAX			0x7fff
#define	T5410_HPI_RAM_LEN		(T5410_HPIA_MAX-T5410_HPIA_MIN+1)
#define	T5410_HPIA_XRAM_MIN		0x18000
#define	T5410_HPIA_XRAM_MAX		0x1ffff
#define	T5410_HPI_XRAM_LEN		(T5410_HPIA_XRAM_MAX-T5410_HPIA_XRAM_MIN+1)

#define	T5416_HPIA_MIN			0x0060
#define	T5416_HPIA_MAX			0x7fff
#define	T5416_HPI_RAM_LEN		(T5416_HPIA_MAX-T5416_HPIA_MIN+1)
#define	T5416_HPIA_XRAM_MIN		0x18000
#define	T5416_HPIA_XRAM_MAX		0x1ffff
#define	T5416_HPI_XRAM_LEN		(T5416_HPIA_XRAM_MAX-T5416_HPIA_XRAM_MIN+1)


#define	T54X_HPIA_XRAM_MAX		0x1ffff	// (abslolute max of HPI address for all C54x DSPs


#define T54X_HPIC_DATA			(inpw(T54X_HPIC_RG) & T54X_HPIC_READ_BITMASK)
#define T54X_SET_HPIC(d)		outpw(T54X_HPIC_RG,(((d&T54X_HPIC_READ_BITMASK)<<8)&0xff00) | (d&T54X_HPIC_READ_BITMASK))

#define T54X_SET_HPIC_BOB		outpw(T54X_HPIC_RG,0x0101)
#define T54X_HPIC_SMODE_DATA		((inpw(T54X_HPIC_RG))>>1 & 0x1)
#define T54X_HPIC_HINT_DATA		((inpw(T54X_HPIC_RG))>>3 & 0x1)
#define T54X_SET_HPIC_DSPINT		outpw(T54X_HPIC_RG,0x0505)
#define T54X_CLR_HPIC_HINT		outpw(T54X_HPIC_RG,0x0909)
#define T54X_HPIC_XHPIA_DATA		((inpw(T54X_HPIC_RG))>>4 & 0x1)
#define T54X_SET_HPIC_XHPIA		outpw(T54X_HPIC_RG,0x1111)
#define T54X_CLR_HPIC_XHPIA		outpw(T54X_HPIC_RG,0x0101)

#define T54X_HPIA_DATA			(inpw(T54X_HPIA_RG))
#define T54X_SET_HPIA(d)		outpw(T54X_HPIA_RG,d)
#define T54X_HPIA_RESET			outpw(T54X_HPIA_RG,0)
#define T54X_SET_XHPIA(d)		{T54X_SET_HPIC_XHPIA;outpw(T54X_HPIA_RG,((d&0x7f)<<8) | (d&0x7f));T54X_CLR_HPIC_XHPIA;}
#define T54X_XHPIA_RESET		{T54X_SET_HPIC_XHPIA;outpw(T54X_HPIA_RG,0);T54X_CLR_HPIC_XHPIA;}

#define T54X_HPID_DATA			inpw(T54X_HPID_RG)
#define T54X_SET_HPID(d)		outpw(T54X_HPID_RG,d)
#define T54X_HPID_AINC_DATA		inpw(T54X_HPID_RG_AINC)
#define T54X_SET_HPID_AINC(d)		outpw(T54X_HPID_RG_AINC,d)

#define T54X_HPI_INIT			{outpw(T54X_HPIC_RG,0x0909);T54X_HPIA_RESET;if(T5410_BOARD) T54X_XHPIA_RESET;}

//------------------- UECM/ECC ----------------------
#define	T54X_EMU_OFF			0
#define	T54X_EMU_IO_BADDR_DEFAULT	0x240
#define	T54X_ECC_IO_BADDR_CNF_QTY	8
#define	T54X_UECM_IO_BADDR_CNF_QTY	4
#define T54X_EMU_MDSP			0
#define T54X_EMU_XDSP			1


int	T54X_emu_io_baddr_data();
int 	T54X_set_emu_io_baddr(unsigned io_addr);
int 	T54X_set_emu_mdsp();
int 	T54X_set_emu_xdsp();
int 	T54X_set_emu_reset();
int 	T54X_emu_path_data();

#define T54X_set_emu_off() 		(T54X_set_emu_xdsp())
#define T54X_set_ecc_off() 		(T54X_set_emu_xdsp())
#define T54X_ECC_OFF	 		(T54X_set_emu_xdsp())
#define T54X_EMU(baddr)			(T54X_set_emu_io_baddr(baddr))
#define T54X_EMU_DEFAULT		(T54X_set_emu_io_baddr(T54X_EMU_IO_BADDR_DEFAULT))
#define T54X_EMU_SELECT_MDSP		(T54X_set_emu_mdsp())
#define T54X_EMU_SELECT_XDSP		(T54X_set_emu_xdsp())
#define T54X_EMU_RESET			(T54X_set_emu_reset())


//------------------- utility functions -----------------------------
int T54X_open(unsigned);
int T54X_close();
int T54X_last_err();
int T54X_err_flag();
int T54X_clr_err_flag();
int T54X_last_err_message(char *);

